from __init__ import Test, TestCase
# from utesting import Test, TestCase (for real using)

t = Test()

cases1 = [TestCase({"a": 100000}, 100000), TestCase({"a": 200000}, 200000), TestCase({"a": 200000}, 300000)]

@t.mark_test_unit(cases=cases1)
def func1(a):
    n = 0
    for i in range(0, a):
        n += 1
    return n

cases2 = [TestCase({"a": [1, 5, 2, 5]}, [1, 2, 5, 5]), TestCase({"a": [1, 7, 3, 7, 9, 0]}, [0, 1, 3, 7, 7, 9])]

@t.mark_test_unit(cases=cases2)
def func2(a):
    k = 0
    while k < len(a) - 1:
        k = 0
        for j in range(0, len(a)-1):
            if a[j] > a[j+1]:
                a[j] = a[j] + a[j+1]
                a[j+1] = a[j] - a[j+1]
                a[j] = a[j] - a[j+1]
            else:
                k += 1
    return a

@t.mark_test_unit(cases=[TestCase({"a": 1}, 1)], only_errors=True)
def func3(a):
    a = a/0

class A:

    c = 2

    def func4(self, a):
        return a / self.c

a = A()

t.add_test_unit(a.func4, [TestCase({"a": 1}, 0.5)])

t.test_all()

"""
Output:

****************************************************************************************************
UNIT: func1
----------------------------------------------------------------------------------------------------
CASE 0:
    Agruments: {'a': 100000}
    Correct answer: 100000
    Returned answer: 100000
    Result: PASSED
    Time: 0.011001825332641602 seconds
----------------------------------------------------------------------------------------------------
CASE 1:
    Agruments: {'a': 200000}
    Correct answer: 200000
    Returned answer: 200000
    Result: PASSED
    Time: 0.023005247116088867 seconds
----------------------------------------------------------------------------------------------------
CASE 2:
    Agruments: {'a': 200000}
    Correct answer: 300000
    Returned answer: 200000
    Result: FAILED
    Time: 0.021956205368041992 seconds
----------------------------------------------------------------------------------------------------
****************************************************************************************************
UNIT: func2
----------------------------------------------------------------------------------------------------
CASE 0:
    Agruments: {'a': [1, 2, 5, 5]}
    Correct answer: [1, 2, 5, 5]
    Returned answer: [1, 2, 5, 5]
    Result: PASSED
    Time: 0.0 seconds
----------------------------------------------------------------------------------------------------
CASE 1:
    Agruments: {'a': [0, 1, 3, 7, 7, 9]}
    Correct answer: [0, 1, 3, 7, 7, 9]
    Returned answer: [0, 1, 3, 7, 7, 9]
    Result: PASSED
    Time: 0.0 seconds
----------------------------------------------------------------------------------------------------
****************************************************************************************************
UNIT: func3
----------------------------------------------------------------------------------------------------
CASE 0: ERROR ( division by zero )
----------------------------------------------------------------------------------------------------
****************************************************************************************************
UNIT: func4
----------------------------------------------------------------------------------------------------
CASE 0:
    Agruments: {'a': 1}
    Correct answer: 0.5
    Returned answer: 0.5
    Result: PASSED
    Time: 0.0 seconds
----------------------------------------------------------------------------------------------------
****************************************************************************************************
ALL CASES PASSED :)
****************************************************************************************************
"""